#pragma once

#include <vector>
#include <memory>

class Node;
class Edge;
class TriFace;

using NodePtr = std::unique_ptr<Node>;
using EdgePtr = std::unique_ptr<Edge>;
using TriFacePtr = std::unique_ptr<TriFace>;

using VecNodes = std::vector<NodePtr>;
using VecEdges = std::vector<EdgePtr>;
using VecFaces = std::vector<TriFacePtr>;

class TriMesh
{
    TriMesh() = default;

    void populate(const VecNodes& nodes, const VecEdges& edges, const VecFaces& faces);

private:
    std::vector<std::unique_ptr<Node> > mNodes;
    std::vector<std::unique_ptr<Edge> > mEdges;
    std::vector<std::unique_ptr<TriFace> > mFaces;
};
